'From TeaSqueak3.6 of 8 February 2004 [latest update: #594] on 19 May 2004 at 2:05:29 am'!
"Change Set:		Shrine
Date:			18 May 2004
Author:			Takashi Yamamiya

A simple space.
"!

CroquetPrivatePlace subclass: #CroquetMinimumPlace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-CroquetPlace'!
TeapotMorph subclass: #MinimumTeapotMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Tea'!

!CroquetPlace methodsFor: 'shrine' stamp: 'tak 5/19/2004 01:22'!
makeShrine
	| win sp2 p1 p2  pic |

	p1 _ TPortal new.

	sp2 _ TSpace new.
	sp2 url: 'http://xxx.xxx.xxx'.

	self makeShrineSky: sp2.
	self makeShrineFloor: sp2.
	self makeShrineWall: sp2.

	win _ TWindow new.
	win translationX: -20 y: 0.0 z: -2.0.
	win contents: p1.
	root addChild: win.
	pic _ TTexture
				new initializeWithFileName: 'komainu.bmp'
				mipmap: true
				shrinkFit: false.
	win rectFront: pic.

	win closeContents.

	p2 _ TPortal new.
	win _ TWindow new.
	win rotationAroundY: 225.
	win translationX: 20.0 y:0.0 z: 10.0.
	win contents: p2.
	sp2 addChild: win.
	p1 linkPortal: p2.
! !

!CroquetPlace methodsFor: 'shrine' stamp: 'tak 5/19/2004 01:06'!
makeShrineFloor: space 
	| floor mat |
	floor _ TCylinder new.
	floor topRadius: 0.0.
	floor baseRadius: 50.0.
	floor capped: true.
	floor height: 0.5.

	floor slices: 60.
"	floor rotationAroundX: 180."
	floor translationX: 0 y: -4 z: 0.
	mat _ TMaterial new.
	mat ambientColor: #(0.5 1.0 0.8 0.5 ) asFloatArray.
	mat diffuseColor: #(0.5 1.0 0.8 0.5 ) asFloatArray.
	floor material: mat.
	space addChild: floor.
! !

!CroquetPlace methodsFor: 'shrine' stamp: 'tak 5/18/2004 21:14'!
makeShrineSky: space 
	| lt sky |
	lt _ TLight new.
	lt rotationAroundZ: 120.
	lt addRotationAroundY: -10.
	lt translationX: 0 y: 0 z: 0.
	space addChild: lt.
	sky _ TSkyBox new initializeWithFileName: 'MLL'.
	space addChild: sky! !

!CroquetPlace methodsFor: 'shrine' stamp: 'tak 5/18/2004 21:08'!
makeShrineWall: space 
| tmat with pwith tt |
tmat _ TMaterial new.
tmat ambientColor: #(1.0 1.0 1.0 1.0) asFloatArray.
tmat diffuseColor: #(1.0 1.0 1.0 1.0) asFloatArray.

with _ 120.
pwith _ with * 0.7. 
tt _ TTexture new initializeWithFileName: 'shrine1.jpg' mipmap: true shrinkFit: false.
tt extent: (pwith @ (pwith * tt aspect)).
tt translationX: 0.0 y: tt extent y / 6 z: with / 2 negated.
tt material: tmat.
space addChild: tt.

tt _ TTexture new initializeWithFileName: 'shrine2.jpg' mipmap: true shrinkFit: false.
tt extent: (pwith @ (pwith * tt aspect)).
tt translationX: with / 2 y: tt extent y / 6 z: 0.0.
tt rotationAroundY: -90.
tt material: tmat.
space addChild: tt.

tt _ TTexture new initializeWithFileName: 'shrine3.jpg' mipmap: true shrinkFit: false.
tt extent: (pwith @ (pwith * tt aspect)).
tt translationX: 0.0 y: tt extent y / 6 z: with / 2.
tt rotationAroundY: -180.
tt material: tmat.
space addChild: tt.

tt _ TTexture new initializeWithFileName: 'shrine4.jpg' mipmap: true shrinkFit: false.
tt extent: (pwith @ (pwith * tt aspect)).
tt rotationAroundY: -270.
tt translationX: (with / 2) negated y: tt extent y / 6 z: 0.0.
tt material: tmat.
space addChild: tt.
! !


!CroquetMinimumPlace class methodsFor: 'as yet unclassified' stamp: 'tak 5/18/2004 21:04'!
buildPlace
	self
		buildPlace: [:place | 
			| tframe ac logo | 
			place url: 'http://xxx.xxx.xxx/'.
			place makeLight.
			place makeFloorFileName: 'graph32.bmp'.
			ac _ TUserCamera new initializeWithViewPort: Croquet world morph.
			Croquet world activeCamera: ac.
			ac pointer tool color: Croquet world myColor.
			ac viewClip: false.
			place root addChild: ac.
			ac activate.
			ac translationX: 0 y: 0 z: 30.
			ac avatar: (place loadAvatar: Croquet world morph avatarPath).
			ac enter: place root.
			ac snapshot.
			ac startRendering.
			place makeMirror.
			place makeShrine.
			place makeAGateway: (B3DMatrix4x4 identity translation: 0 @ 0 @ -8)]
		private: true! !


!CroquetTeapotPlace class methodsFor: 'as yet unclassified' stamp: 'tak 5/19/2004 01:13'!
buildPlace
| waveDemo |
self buildPlace: [ :place |
	| tframe t1 t2 |

	t1_ Croquet world activeCamera globalTransform.
	t1 translation: t1 translation + (4*Croquet world activeCamera lookAt).
	t2 _  (B3DMatrix4x4 identity translation: (0@0@-8)).
	place makePortalFrom: place root fromTrans: t1 to: Croquet world activeCamera root toTrans: t2. 
	place root url: 'http://www.reed.com/TeaLand/spaces/intro.tea'.
"	place root ambientSound: (place loadAmbientSound:'intro.mp3')."

	place makeLight.

	place makeFloorFileName:'stone.bmp'.
	place makeUnderwater3.

	waveDemo _ place makeWaveDemo.
	place makeWaveDemo: waveDemo at: -30@-1@-30 in: place root.
	place makeWaveDemo: waveDemo at: 30@-1@-30 in: place root.
	place makeWaveDemo: waveDemo at: 30@-1@30 in: place root.
	place makeWaveDemo: waveDemo at: -30@-1@30 in: place root.

	place makeKay.
	place makePyramid.
	place makeGallery.
	place makeDungeon.
	place makeChess.
	place makeProjectLink.
	place makePooh.
	place makeMirror.
	place makeMars.
	place makeShrine.
"	place makeHoliday.
	place makeClock.
	place makeSlime.
	"
"	place makeManual."

	tframe := TMyCube new.
	place root addChild: tframe.
	place makeFlag: place root.
	tframe _ TSkyBox new initializeWithFileName: 'MLL'.
	place root addChild: tframe.

	place makeAGateway: (B3DMatrix4x4 identity translation: (0@0@-8)).

].! !


!MinimumTeapotMorph methodsFor: 'initialization' stamp: 'tak 5/17/2004 12:25'!
initialize
	super initialize.
	bounds _ 0 @ 0 corner: 320 @ 240.
! !

!MinimumTeapotMorph methodsFor: 'initialization' stamp: 'tak 5/17/2004 12:13'!
initializeDefaultSpace
		cWorld buildPlace: CroquetTestPlace.! !

!MinimumTeapotMorph methodsFor: 'initialization' stamp: 'tak 5/18/2004 13:17'!
requestInitialSpace
	| fileStream string |
	fileStream _ CrLfFileStream readOnlyFileNamed: 'avatarBunny.txt'.
	fileStream
		ifNotNil: [fileStream _ fileStream ascii.
			string _ fileStream next: fileStream size.
			avatarPath _ Compiler evaluate: string].
	Cursor wait
		showWhile: [cWorld buildPlace: CroquetMinimumPlace.
			cWorld drainQueue.
			croquetInitialized _ true]! !


!MinimumTeapotMorph class methodsFor: 'as yet unclassified' stamp: 'tak 5/17/2004 12:23'!
descriptionForPartsBin
	^super descriptionForPartsBin! !

